<template>
  <div class="row">
        <div class="col-12 text-white">
            <h2>Imagenes</h2>
        </div>
        <div class="col-12">
            <div class="grid">
                <div class="imagen-container" v-for="publicacion in miniaturasAMostrar" :key="publicacion.id" >
                    <img v-if="publicacion.img" class="imagen-img" :src="publicacion.img" alt="" @click="mostrarModalImagenes(publicacion)">
                </div>
            </div>
        </div>
    </div>
<!--modal -->
    <div id="modal-imagen">
        <div class="container-fluid h-100" id="contenido-modal-imagen">
            <div id="boton-cerrar-modal-imagen" @click="ocultarModalImagenes"><i class="bi bi-x-circle-fill"></i></div>
            <div id="boton-right-modal-imagen" @click="moverImagenADerecha"><i class="bi bi-arrow-right-circle-fill h-100 w-100"></i></div>
            <div id="boton-left-modal-imagen" @click="moverImagenAIzquierda"><i class="bi bi-arrow-left-circle-fill h-100 w-100"></i></div>
            <div class="row h-100"> 
                <div class="col-12 h-100">
                    <div class="row h-100 p-3" v-if="imagenSeleccionada">
                        <div class="col-12 h-100" id="contenedor-imagen-modal">
                            <img :src="imagenSeleccionada.img">
                            <div class="container-fluid" id="imagen-modal-texto">
                                <div class="row">
                                    <div class="col-12">
                                        <p>{{ imagenSeleccionada.textoDeLaImagen }}</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import {buscarImagenPubli} from "../../Services/muro/MuroService.js"
export default {
    data(){
        return{
            imagenes:[
                
            ],
            imagenSeleccionada:null,
            mirandoUnaImagen:false
        }
    },
    props:{
        publicaciones:{
            type: Array,
            required: true
        }
    },
    methods:{
        mostrarModalImagenes(publicacion){
            let modal = document.getElementById("modal-imagen");
            let contenido=document.getElementById("contenido-modal-imagen");
            this.imagenSeleccionada=publicacion;
            modal.style.display = "block";

            this.mirandoUnaImagen=true;
            setTimeout(() => {
                modal.style.background = "rgba(0, 0, 0, 0.65)";
                contenido.style.opacity="100%";
                modal.style.setProperty("backdrop-filter", "blur(10px)");
            }, 0);
        },
        ocultarModalImagenes(){
            let modal=document.getElementById("modal-imagen");
            let contenido=document.getElementById("contenido-modal-imagen");
            modal.style.setProperty("backdrop-filter", "blur(0px)");
            modal.style.background = "rgba(0, 0, 0, 0)";
            contenido.style.opacity="0";

            this.mirandoUnaImagen=false;
            setTimeout(()=>{
                modal.style.display="none";
            },200)
        },
        moverImagenADerecha(){
            let indice=this.imagenes.indexOf(this.imagenSeleccionada)+1;
            if(indice>this.imagenes.length-1){
                indice=0;
            }
            this.imagenSeleccionada=this.imagenes[indice];
        },
        moverImagenAIzquierda(){
            let indice=this.imagenes.indexOf(this.imagenSeleccionada)-1;
            if(indice<0){
                indice=this.imagenes.length-1;
            }
            this.imagenSeleccionada=this.imagenes[indice];
        },
        async obtenerImgs(){
            try{
                for (let i = 0; i < this.imagenes.length; i++) {
                    const element = this.imagenes[i];
                    element.img= await buscarImagenPubli(element.imagenes[0]);
                }

            }catch(e){
                console.log(e)
            }
        }
    },
    computed:{
        miniaturasAMostrar(){
            let array=[];
            for(let i=0; i<this.imagenes.length;i++){
                if(i>7) break;
                array.push(this.imagenes[i]);
            }
            return array;
        }
    },
    mounted(){
        this.imagenes=this.publicaciones;
        this.obtenerImgs();
        window.addEventListener("keydown",(event)=>{
            if(this.mirandoUnaImagen){
                if(event.key === "ArrowRight"){
                    this.moverImagenADerecha();
                }else if(event.key === "ArrowLeft"){
                    this.moverImagenAIzquierda();
                }else if(event.key === "Escape"){
                    this.ocultarModalImagenes();
                }
            }
        })
    }

}
</script>

<style scoped>
.grid{
    display: grid;
    grid-template-columns: 25% 25% 25% 25%;
    grid-template-rows: 50% 50%;
}
.imagen-container{
    aspect-ratio: 1/1;
    padding: 8%;
    transition: all .2s;
}
.imagen-container:hover{    
    transform: translateY(-10px);
}
.imagen-img{
    width: 100%;
    height: 100%;
    object-fit: cover;
    border-radius: 5%;
    outline: 2px solid white;
    cursor: pointer;
}

/* Modal */
#modal-imagen{
    display: none;
    position: fixed;
    transition: background-color .2s;
    height: 100vh;
    width: 100%;
    top:0;
    left:0;
    z-index: 100;
}
#contenido-modal-imagen{
    opacity: 0;
    transition: opacity .2s;
}
#contenido-modal-imagen img{
    height: 100%;
    width: 100%;
    object-fit: contain;
}
#boton-cerrar-modal-imagen{
    color: white;
    position: fixed;
    margin: 40px;
    top: 0;
    right: 0;
    z-index: 200;
    transition: all .1s;
    transform: scale(3);
}
#boton-cerrar-modal-imagen:hover{
    cursor: pointer;
    transform: scale(4);
}
#contenedor-imagen-modal{
    position: relative;
}
#imagen-modal-texto{
    
    position: absolute;
    color: white;
    text-shadow: 0px 0px 1px black,0px 0px 2px black,0px 0px 3px black,0px 0px 4px black;
    width: 80vw;
    height: auto;
    bottom: 0;
    left: 50%;
    transform: translateX(-50%);
}
#boton-right-modal-imagen{
    position: fixed;
    margin: 0px 40px 0px 0px;
    color: white;
    z-index: 200;
    right: 0;
    top: 50%;
    cursor: pointer;
    user-select: none;
    transform: scale(3);
    transition: all 0.3s;
}
#boton-right-modal-imagen:hover{
    transform: scale(4);
}
#boton-left-modal-imagen{
    position: fixed;
    margin: 0px 0 0px 40px;
    color: white;
    
    z-index: 200;
    left: 0;
    top: 50%;
    cursor: pointer;
    user-select: none;
    transform: scale(3);
    transition: all 0.3s;
}
#boton-left-modal-imagen:hover{
    transform: scale(4);
}
</style>